package exnihilocreatio.tiles;

import exnihilocreatio.networking.PacketHandler;
import exnihilocreatio.util.BlockInfo;
import lombok.Getter;
import net.minecraft.block.Block;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.AxisAlignedBB;

import javax.annotation.Nonnull;

public class TileInfestedLeaves extends BaseTileEntity implements ITileLeafBlock {

    @Getter
    private IBlockState leafBlock = Blocks.field_150362_t.func_176223_P();


    @Override
    @Nonnull
    public AxisAlignedBB getRenderBoundingBox() {
        return INFINITE_EXTENT_AABB;
    }

    public void setLeafBlock(IBlockState block) {
        leafBlock = block;
        PacketHandler.sendNBTUpdate(this);
    }

    @Override
    @Nonnull
    public NBTTagCompound func_189515_b(NBTTagCompound tag) {
        tag = super.func_189515_b(tag);
        tag.func_74778_a("leafBlock", leafBlock.func_177230_c().getRegistryName() == null ? "" : leafBlock.func_177230_c().getRegistryName().toString());
        tag.func_74768_a("leafBlockMeta", leafBlock.func_177230_c().func_176201_c(leafBlock));
        return tag;
    }

    @SuppressWarnings("deprecation")
    @Override
    public void func_145839_a(NBTTagCompound tag) {
        super.func_145839_a(tag);

        if (tag.func_74764_b("leafBlock") && tag.func_74764_b("leafBlockMeta")) {
            BlockInfo leaves = new BlockInfo(Block.func_149684_b(tag.func_74779_i("leafBlock")), tag.func_74762_e("leafBlockMeta"));
            if (leaves.isValid())
                leafBlock = leaves.getBlockState();
            else leafBlock = Blocks.field_150362_t.func_176223_P();
        } else {
            leafBlock = Blocks.field_150362_t.func_176223_P();
        }
    }

    @Override
    public boolean hasFastRenderer() {
        return false;
    }
}
